{include for unzip.pas: Copy stored file}

{C code by info-zip group, translated to Pascal by Christian Ghisler}
{based on unz51g.zip}

{************************* copy stored file ************************************}
function copystored(originalcrc:longint):integer;
var readin:longint;
    outcnt:word;
    {$ifdef encryption}
    firstblock:boolean;
    {$endif}
begin
  {$ifdef encryption}
  firstblock:=true;
  {$endif}
  {$ifdef wincmd}
  while (compsize>reachedsize) and not totalabort do begin
  {$else}
  while (reachedsize<compsize) and not totalabort do begin
  {$endif}
    if compsize-reachedsize>wsize then
      readin:=wsize
    else
      readin:=trunc(compsize-reachedsize);
    blockread(infile,slide[0],readin,outcnt);  {Use slide as buffer}
    {$ifdef encryption}
    if decrypt then begin
      DecryptBuffer(slide,outcnt);
      if firstblock then begin  {Remove encryption header!}
        if outcnt>=12 then dec(outcnt,12)
                      else outcnt:=0;
    {    if (originalcrc<>0) and (byte(slide[11])<>originalcrc shr 24) then begin
          copystored:=unzip_CrcErr;
          exit
        end;}      {Not correct for some zip-net versions!}
        move(slide[12],slide[0],outcnt);
        dec(readin,12);
        compsize:=compsize-12;
        firstblock:=false;
      end;
    end{$ifdef win32} else if global_aes_strength>0 then
      AesDecryptBuffer(slide,outcnt);
    {$else};
    {$endif}
    {$endif}
    if (doserror<>0) then begin
      copystored:=unzip_ReadErr;
      exit
    end;
    if not flush(outcnt) then begin  {Flushoutput takes care of CRC too}
      copystored:=unzip_WriteErr;
      exit
    end;
    reachedsize:=reachedsize+outcnt;
    messageloop;      {Other programs, or in DOS: keypressed?}
    {$ifdef windows}
    showpercent;
    {$endif}
    if outcnt<>readin then begin
      longclose(infile);
      if infilename[1]=':' then seektrack0(infilename[0]);
      if asktoswapdisk(dlghandle,currentdisk+1,infilename) then begin
        infile:=longreset(infilename,0,0);
        if doserror<>0 then begin
          infile:=invalid_handle_value;
          copystored:=unzip_ReadErr;
          exit
        end;
      end else begin
        copystored:=unzip_ReadErr;
        infile:=invalid_handle_value;
        exit
      end;
    end;
  end;
  if not totalabort then
    copystored:=unzip_Ok
  else
    copystored:=unzip_Userabort;
end;
