{include for unzip.pas: Inflate deflated file}

{C code by info-zip group, translated to Pascal by Christian Ghisler}
{based on unz51g.zip}

{This function takes most of the time}
{$ifdef win32}
{$O+}
{$endif}
function inflate_codes(tl,td:phuftlist;bl,bd:integer):integer; {$ifdef win32} pascal;{faster!} {$endif}
var t:phuft;         {pointer to table entry}
    e:byte;          {table entry flag/number of extra bits}
    slide2:pchar;
{$ifdef win32}
    ml,md:integer;     {masks for bl and bd bits}
    n,w2,d,e1:integer;
{$else}
    ml,md:word;        {masks for bl and bd bits}
    n,w2,d,e1:word;    {length and index for copy}
{$endif}

begin
  { inflate the coded data }
  slide2:=slide;
  w2:=w;
  ml:=mask_bits[bl];          {precompute masks for speed}
  md:=mask_bits[bd];
  while not (totalabort or zipeof) do begin
    NEEDBITS(bl);
    t:=@tl^[b and ml];
    e:=t^.e;
    if e>32 then repeat       {then it's a literal}  {was: e>16}
      if (e=99) or (t^.v_t=nil) then begin
        inflate_codes:=unzip_ZipFileErr;
        w:=w2;
        exit
      end;
      DUMPBITS(t^.b);
      e:=e and 31;      {dec(e,16); }
      NEEDBITS(e);
      t:=@t^.v_t^[b and mask_bits[e]];
      e:=t^.e;
    until e<=32;                { e<=16 }
    DUMPBITS(t^.b);
    if e=32 then begin          { e=16 }
      slide2[w2]:=char(t^.v_n);
      inc(w2);
      if w2=WSIZE then begin
        if not flush(w2) then begin
          inflate_codes:=unzip_WriteErr;
          w:=w2;
          exit;
        end;
        w2:=0
      end;
    end else begin                {it's an EOB or a length}
      if e=31 then begin {Ende}   {exit if end of block}   { e=15 }
        inflate_codes:=unzip_Ok;
        w:=w2;
        exit;
      end;
      NEEDBITS(e);                 {get length of block to copy}
      n:=t^.v_n+(b and mask_bits[e]);

      DUMPBITS(e);
      NEEDBITS(bd);                {decode distance of block to copy}
      t:=@td^[b and md];
      e:=t^.e;
      if e>32 then repeat          {e>16}
        if (e=99) or (t^.v_t=nil) then begin  {Fix for bad gzip file test suite!}
          inflate_codes:=unzip_ZipFileErr;
          w:=w2;
          exit
        end;
        DUMPBITS(t^.b);
        e:=e and 31;      {dec(e,16);}
        NEEDBITS(e);
        t:=@t^.v_t^[b and mask_bits[e]];
        e:=t^.e;
      until e<=32;        { <=16}
      DUMPBITS(t^.b);

      NEEDBITS(e);
      d:=w2-t^.v_n-b and mask_bits[e];
      DUMPBITS(e);

      {do the copy}
      repeat
        d:=d and (WSIZE-1);
        if d>w2 then e1:=WSIZE-d
                else e1:=WSIZE-w2;
        if e1>n then e1:=n;
        dec(n,e1);

        if (w2-d>=e1) then begin
          move(slide2[d],slide2[w2],e1);
          inc(w2,e1);
          inc(d,e1);
        end else if (w2-d=1) then begin  {Spezialfall: repetiertes Byte!}
          fillchar(slide2[w2],e1,slide2[d]);
          inc(w2,e1);
          inc(d,e1);
        end else begin
          {$ifdef win32}
          asm
            push esi
            push edi
            mov eax,slide2
            mov esi,[d]
            mov edi,[w2]
            add esi,eax
            add edi,eax
            mov ecx,e1
            cld
            rep movsb
            pop edi
            pop esi
          end;
          inc(w2,e1);
          inc(d,e1);
          {$else}
          repeat
           slide2[w2]:=slide2[d];
           inc(w2);
           inc(d);
           dec(e1);
          until (e1=0);
          {$endif}
        end;
        if w2=WSIZE then begin
          if not flush(w2) then begin
            inflate_codes:=unzip_WriteErr;
            w:=w2;
            exit;
          end;
          w2:=0;
        end;
      until n=0;
    end;
  end;
  w:=w2;
  if totalabort then
    inflate_codes:=unzip_userabort
  else
    inflate_codes:=unzip_readErr;
end;
{$ifdef win32}
{$O-}
{$endif}

{$ifndef win32}
function inflate_codes64(tl,td:phuftlist;bl,bd:integer):integer;
var t:phuft;         {pointer to table entry}
    e:byte;          {table entry flag/number of extra bits}
    slide2:pchar;
    ml,md:word;        {masks for bl and bd bits}
    n,w2,d,e1:word;    {length and index for copy}

begin
  { inflate the coded data }
  slide2:=slide;
  w2:=w;
  ml:=mask_bits[bl];          {precompute masks for speed}
  md:=mask_bits[bd];
  while not (totalabort or zipeof) do begin
    NEEDBITS(bl);
    t:=@tl^[b and ml];
    e:=t^.e;
    if e>32 then repeat       {then it's a literal}   {e>16}
      if (e=99) or (t^.v_t=nil) then begin
        result:=unzip_ZipFileErr;
        w:=w2;
        exit
      end;
      DUMPBITS(t^.b);
      e:=e and 31;      {dec(e,16);}
      NEEDBITS(e);
      t:=@t^.v_t^[b and mask_bits[e]];
      e:=t^.e;
    until e<=32;        {e<16}
    DUMPBITS(t^.b);
    if e=32 then begin  {e=16}
      slide2[w2]:=char(t^.v_n);
      if w2=$FFFF then begin
        if not flush($10000) then begin
          result:=unzip_WriteErr;
          w:=w2;
          exit;
        end;
        w2:=0
      end else
        inc(w2);
    end else begin                {it's an EOB or a length}
      if e=31 then begin {Ende}   {exit if end of block}      {e=15}
        result:=unzip_Ok;
        w:=w2;
        exit;
      end;
      NEEDBITS(e);                 {get length of block to copy}
      n:=t^.v_n+(b and mask_bits[e]);

      DUMPBITS(e);
      NEEDBITS(bd);                {decode distance of block to copy}
      t:=@td^[b and md];
      e:=t^.e;
      if e>32 then repeat           {e>16}
        if (e=99) or (t^.v_t=nil) then begin
          result:=unzip_ZipFileErr;
          w:=w2;
          exit
        end;
        DUMPBITS(t^.b);
        e:=e and 31;      {dec(e,16);}
        NEEDBITS(e);
        t:=@t^.v_t^[b and mask_bits[e]];
        e:=t^.e;
      until e<=32;           {e<=16}
      DUMPBITS(t^.b);

      NEEDBITS(e);
      d:=w2-t^.v_n-b and mask_bits[e];
      DUMPBITS(e);

      {do the copy}
      repeat
        d:=d and $FFFF;
        if d>w2 then e1:=$10000-d
                else e1:=$10000-w2;
        if e1>n then e1:=n;
        dec(n,e1);

        if (w2-d>=e1) then begin
          move(slide2[d],slide2[w2],e1);
          inc(w2,e1);
          inc(d,e1);
        end else if (w2-d=1) then begin  {Spezialfall: repetiertes Byte!}
          fillchar(slide2[w2],e1,slide2[d]);
          inc(w2,e1);
          inc(d,e1);
        end else begin
          repeat
           slide2[w2]:=slide2[d];
           inc(w2);
           inc(d);
           dec(e1);
          until (e1=0);
        end;
        if w2=0 then begin  {Wraparound -> full!}
          if not flush($10000) then begin
            result:=unzip_WriteErr;
            w:=w2;
            exit;
          end;
          w2:=0;
        end;
      until n=0;
    end;
  end;
  w:=w2;
  if totalabort then
    result:=unzip_userabort
  else
    result:=unzip_readErr;
end;
{$endif}

{**************************** "decompress" stored block **************************}

function inflate_stored:integer;
var n:word;            {number of bytes in block}
    slide2:pchar;
    {$ifdef win32}
    wsize1:integer;
    {$else}
    wsize1:word;
    {$endif}
    wsize2:longint;
begin
  {$ifdef win32}
  wsize1:=WSIZE;
  wsize2:=WSIZE;
  {$else}
  if deflate64mode then begin
    wsize1:=0;
    wsize2:=$10000;
  end else begin
    wsize1:=$8000;
    wsize2:=$8000;
  end;
  {$endif}
  slide2:=slide;
  {go to byte boundary}
  n:=k and 7;
  dumpbits(n);
  {get the length and its complement}
  NEEDBITS(16);
  n:=b and $ffff;
  DUMPBITS(16);
  NEEDBITS(16);
  if (n<>(not b) and $ffff) then begin
    inflate_stored:=unzip_zipFileErr;
    exit
  end;
  DUMPBITS(16);
  while (n>0) and not (totalabort or zipeof) do begin {read and output the compressed data}
    dec(n);
    NEEDBITS(8);
    slide2[w]:=char(b);
    inc(w);
    if w=WSIZE1 then begin
      if not flush(WSIZE2) then begin
        inflate_stored:=unzip_WriteErr;
        exit
      end;
      w:=0;
    end;
    DUMPBITS(8);
  end;
  if totalabort then inflate_stored:=unzip_UserAbort
    else if zipeof then inflate_stored:=unzip_readErr
      else inflate_stored:=unzip_Ok;
end;

{**************************** decompress fixed block **************************}

function inflate_fixed:integer;
var i:integer;               {temporary variable}
    tl,                      {literal/length code table}
    td:phuftlist;                {distance code table}
    bl,bd:integer;           {lookup bits for tl/bd}
    l:array[0..287] of word; {length list for huft_build}

begin
  {set up literal table}
  for i:=0 to 143 do l[i]:=8;
  for i:=144 to 255 do l[i]:=9;
  for i:=256 to 279 do l[i]:=7;
  for i:=280 to 287 do l[i]:=8; {make a complete, but wrong code set}
  bl:=7;
  i:=huft_build(pword(@l),288,257,Pcplens,Pcplext,@tl,bl);
  if i<>huft_complete then begin
    inflate_fixed:=i;
    exit
  end;
  for i:=0 to 31 do l[i]:=5;    {make an incomplete code set} {Was: to 29}
  bd:=5;
  i:=huft_build(pword(@l),32,0,Pcpdist,Pcpdext,@td,bd);       {Was: 30}
  if i>huft_incomplete then begin
    huft_free(tl);
    inflate_fixed:=unzip_ZipFileErr;
    exit
  end;
  {$ifndef win32}
  if deflate64mode then
    inflate_fixed:=inflate_codes64(tl,td,bl,bd)
  else
  {$endif}
  inflate_fixed:=inflate_codes(tl,td,bl,bd);
  huft_free(tl);
  huft_free(td);
end;

{**************************** decompress dynamic block **************************}

function inflate_dynamic:integer;
var i:integer;                      {temporary variables}
    j,
    l,                              {last length}
    m,                              {mask for bit length table}
    n:word;                         {number of lengths to get}
    tl,                             {literal/length code table}
    td:phuftlist;                   {distance code table}
    bl,bd:integer;                  {lookup bits for tl/bd}
    nb,nl,nd:word;                  {number of bit length/literal length/distance codes}
    ll:array[0..288+32-1] of word;  {literal/length and distance code lengths}

begin
  {read in table lengths}
  NEEDBITS(5);
  nl:=257+word(b) and $1f;
  DUMPBITS(5);
  NEEDBITS(5);
  nd:=1+word(b) and $1f;
  DUMPBITS(5);
  NEEDBITS(4);
  nb:=4+word(b) and $f;
  DUMPBITS(4);
  if (nl>288) or (nd>32) then begin
    inflate_dynamic:=1;
    exit
  end;
  fillchar(ll,sizeof(ll),#0);

  {read in bit-length-code lengths}
  for j:=0 to nb-1 do begin
    NEEDBITS(3);
    ll[border[j]]:=b and 7;
    DUMPBITS(3);
  end;
  for j:=nb to 18 do ll[border[j]]:=0;

  {build decoding table for trees--single level, 7 bit lookup}
  bl:=7;
  i:=huft_build(pword(@ll),19,19,nil,nil,@tl,bl);
  if i<>huft_complete then begin
    if i=huft_incomplete then huft_free(tl); {other errors: already freed}
    inflate_dynamic:=unzip_ZipFileErr;
    exit
  end;

  {read in literal and distance code lengths}
  n:=nl+nd;
  m:=mask_bits[bl];
  i:=0; l:=0;
  while word(i)<n do begin
    NEEDBITS(bl);
    td:=@tl^[b and m];
    if td=nil then begin     {Fix to blaster worm extract crash} 
      inflate_dynamic:=unzip_zipfileErr;
      exit
    end;
    j:=phuft(td)^.b;
    DUMPBITS(j);
    j:=phuft(td)^.v_n;
    if j<16 then begin            {length of code in bits (0..15)}
      l:=j;                       {ave last length in l}
      ll[i]:=l;
      inc(i)
    end else if j=16 then begin   {repeat last length 3 to 6 times}
      NEEDBITS(2);
      j:=3+b and 3;
      DUMPBITS(2);
      if i+j>n then begin
        inflate_dynamic:=1;
        exit
      end;
      while j>0 do begin
        ll[i]:=l;
        dec(j);
        inc(i);
      end;
    end else if j=17 then begin   {3 to 10 zero length codes}
      NEEDBITS(3);
      j:=3+b and 7;
      DUMPBITS(3);
      if i+j>n then begin
        inflate_dynamic:=1;
        exit
      end;
      while j>0 do begin
        ll[i]:=0;
        inc(i);
        dec(j);
      end;
      l:=0;
    end else begin                {j == 18: 11 to 138 zero length codes}
      NEEDBITS(7);
      j:=11+b and $7f;
      DUMPBITS(7);
      if i+j>n then begin
        inflate_dynamic:=unzip_zipfileErr;
        exit
      end;
      while j>0 do begin
        ll[i]:=0;
        dec(j);
        inc(i);
      end;
      l:=0;
    end;
  end;
  huft_free(tl);        {free decoding table for trees}

  {build the decoding tables for literal/length and distance codes}
  bl:=lbits;
  i:=huft_build(pword(@ll),nl,257,Pcplens,Pcplext,@tl,bl);
  if (i<>huft_complete) or (bl=0){vulnerability check} then begin
    if i=huft_incomplete then huft_free(tl);
    inflate_dynamic:=unzip_ZipFileErr;
    exit
  end;
  bd:=dbits;
  i:=huft_build(pword(@ll[nl]),nd,0,Pcpdist,Pcpdext,@td,bd);
  if (i>huft_incomplete {pkzip bug workaround}) or ((bd=0) and (nl>257)) then begin
    if i=huft_incomplete then huft_free(td);
    huft_free(tl);
    inflate_dynamic:=unzip_ZipFileErr;
    exit
  end;
  {decompress until an end-of-block code}
  {$ifndef win32}
  if deflate64mode then
    inflate_dynamic:=inflate_codes64(tl,td,bl,bd)
  else
  {$endif}
  inflate_dynamic:=inflate_codes(tl,td,bl,bd);
  huft_free(tl);
  huft_free(td);
end;

{**************************** decompress a block ******************************}

function inflate_block(var e:integer):integer;
var t:word;           {block type}

begin
  NEEDBITS(1);
  e:=b and 1;
  DUMPBITS(1);

  NEEDBITS(2);
  t:=b and 3;
  DUMPBITS(2);

  case t of
    2:inflate_block:=inflate_dynamic;
    0:inflate_block:=inflate_stored;
    1:inflate_block:=inflate_fixed;
  else
    inflate_block:=unzip_ZipFileErr;  {bad block type}
  end;
end;

{**************************** decompress an inflated entry **************************}

function inflate(orgcrc:longint):integer;
var e,                 {last block flag}
    r:integer;         {result code}

begin
  inpos:=0;            {Input buffer position}
  readpos:=-1;         {Nothing read}

  {initialize window, bit buffer}
  w:=0;
  k:=0;
  b:=0;
  {$ifdef encryption}
  if decrypt then begin
    CheckCryptCrc(orgcrc);  {Do not use, seems to be wrong for some zip-nt versions}
  end;
  {$endif}
  {decompress until the last block}
  repeat
    r:=inflate_block(e);
    if r<>0 then begin
      inflate:=r;
      flush(w);
      exit
    end;
  until e<>0;

  {flush out slide}
  if not flush(w) then inflate:=unzip_WriteErr
  else inflate:=unzip_Ok;
end;



