{Include file for unzip.pas: global constants, types and variables}

{C code by info-zip group, translated to pascal by Christian Ghisler}
{based on unz51g.zip}

const   {Error codes returned by huft_build}
  huft_complete=0;     {Complete tree}
  huft_incomplete=1;   {Incomplete tree <- sufficient in some cases!}
  huft_error=2;        {bad tree constructed}
  huft_outofmem=3;     {not enough memory}

const wsize32=$8000;          {Size of sliding dictionary}
{$ifdef win32}
      wsize64=$10000;         {Size of sliding dictionary for deflate64}
      INBUFSIZ=8192;        {Size of input buffer}

      salt_size:array[1..3] of byte=(8,12,16);
{$else}
      INBUFSIZ=2048;        {Size of input buffer}
      wsize=$8000;
{$endif}

const b_max=16;
      n_max=288;
      BMAX=16;
      lbits=9;
      dbits=6;

type push=^ush;
     ush=word;
     pbyte=^byte;
     pushlist=^ushlist;
     ushlist=array[0..32767-1] of ush;  {only pseudo-size!!}
     pword=^word;
     pwordarr=^twordarr;
     twordarr=array[0..32767-1] of word;
     iobuf=array[0..inbufsiz-1] of byte;
type pphuft=^phuft;
     phuft=^huft;
     phuftlist=^huftlist;
     huft=packed record
       e,             {# of extra bits}
       b:byte;        {# of bits in code}
       v_n:ush;
       v_t:phuftlist; {Linked List}
     end;
     huftlist=array[0..8190] of huft;
type li=record
       lo,hi:word;
     end;

{pkzip header in front of every file in archive}
type
  plocalheader=^tlocalheader;
  tlocalheader=record
    signature:array[0..3] of char;  {'PK'#1#2}
    extract_ver,
    bit_flag,
    zip_type:word;
    file_timedate:longint;
    crc_32,
    compress_size,
    uncompress_size:longint;
    filename_len,
    extra_field_len:word;
  end;

const inuse:boolean=false;    {is unit already in use -> don't call it again!!!}
      lastusedtime:longint=0; {Time of last usage in timer ticks for timeout!}

{For the AES plugin}
const BLOCK_SIZE = 16;
      IN_BLOCK_LENGTH = 64; //SHA1_BLOCK_SIZE

type      
  {New: These functions are for the AES plugin only, for ZIP-AES handling!}
  sha1_32t = cardinal; //word?;
  aes_32t = cardinal; //word?;
  uint = cardinal; //word?;
  pwdver_array = array [0..1] of byte;
  TAES_ctx = record
     k_sch: array [0..63] of aes_32t;
     n_rnd: aes_32t;
     n_blk: aes_32t;
  end;
  TSHA1_ctx = record
    count: array [0..1] of sha1_32t;
    hash: array [0..4] of sha1_32t;
    wbuf: array [0..15] of sha1_32t;
  end;
  THMAC_ctx = record
     key: array [0..IN_BLOCK_LENGTH-1] of byte;
     ctx: TSHA1_ctx;
     klen: uint;
  end;

  pfcrypt_ctx=^Tfcrypt_ctx;
  Tfcrypt_ctx=record
    nonce: array [0..BLOCK_SIZE-1] of byte;
    encr_bfr: array [0..BLOCK_SIZE-1] of byte;
    encr_ctx: TAES_ctx;
    auth_ctx: THMAC_ctx;
    encr_pos,
    pwd_len,
    mode: uint;
  end;

  TAESBuffer = array [0..15] of byte;
  TAESKey128 = array [0..15] of byte;
  TAESKey256 = array [0..31] of byte;

